=== debian/changelog ===
lief (0.8.3-3) unstable; urgency=medium

  * Update debian/copyright (Closes: #904673)

 -- Hilko Bengen <bengen@debian.org>  Fri, 27 Jul 2018 13:56:21 +0200

lief (0.8.3-2) unstable; urgency=medium

  * Remove debian/files

 -- Hilko Bengen <bengen@debian.org>  Sat, 30 Jun 2018 21:20:12 +0200

lief (0.8.3-1) unstable; urgency=medium

  * Initial release (Closes: #899407)

 -- Hilko Bengen <bengen@debian.org>  Tue, 26 Jun 2018 11:37:53 +0200
