=== debian/control ===
Source: lief
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 10), cmake,
 nlohmann-json-dev,
 libeasyloggingpp-dev,
 libmbedtls-dev,
# python-dev, pybind11-dev, python-setuptools,
# doxygen, python-sphinx, python-sphinx-rtd-theme, fonts-font-awesome
Standards-Version: 4.1.4
Section: libs
Homepage: https://lief-project.github.io/
Vcs-Git: https://salsa.debian.org/debian/lief.git
Vcs-Browser: https://salsa.debian.org/debian/lief

Package: liblief0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${misc:Built-Using}
Description: Library to Instrument Executable Formats
 LIEF is a library for parsing, modifying ELF, PE, and MachO formats.
 Its main features include:
 .
  - Parsing: LIEF can parse ELF, PE, MachO and provides an user-friendly
    API to access to format internals.
  - Modify: It enables to modify some parts of these formats
  - Abstract: Three formats have common features like sections, symbols,
    entry point, etc.. LIEF factors them.
  - API support: LIEF can be used in C, C++, and Python.
 .
 This package contains the shared library.

Package: liblief-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblief0 (= ${binary:Version}), ${misc:Depends}
Built-Using: ${misc:Built-Using}
Description: Library to Instrument Executable Formats -- development files
 LIEF is a library for parsing, modifying ELF, PE, and MachO formats.
 .
 This package contains the static library, header files, and examples.
