=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DDEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) \
		-DLIEF_DOC=0 \
		-DLIEF_PYTHON_API=0 \
		-DLIEF_INSTALL_PYTHON=0 \
		-DLIEF_LOGGING=0

override_dh_install:
	dh_install --fail-missing -X/usr/share/LIEF/examples -X/usr/share/LIEF/cmake

override_dh_gencontrol:
	dh_gencontrol -- -Vmisc:Built-Using="$(shell dpkg-query --showformat='$${source:Package} (=$${source:Version}), ' --show nlohmann-json-dev libeasyloggingpp-dev)"
